#include <iostream.h>
#include <fstream.h>
#include <string.h>
#include <sys/stat.h>

#include "smtpmail.h"
#include "astring.h"
#include "listof.h"

int main(int ac, char* av[])
{
	if (ac == 1)
	{
		cout << "Usage: mailit -host:server -to:address -from:address [-s:\"subject\"] [-file:text] [-html] [-a:filename ...]" << endl;
		return 1;
	}

	AString host, to, from, subject, file;
	SmtpClient smtp;
	struct stat st;
	int i, html = 0;

	for (i = 1; i < ac; i++)
	{
		if (!strncmp(av[i], "-host:", 6))
			host = av[i]+6;
		else if (!strncmp(av[i], "-to:", 4))
			to = av[i]+4;
		else if (!strncmp(av[i], "-from:", 6))
			from = av[i]+6;
		else if (!strncmp(av[i], "-file:", 6))
			file = av[i]+6;
		else if (!strcmp(av[i], "-html"))
			html = 1;
		else if (!strncmp(av[i], "-s:", 3))
		{
			const char* src = av[i]+3;
			subject = "";

			while (*src)
			{
				if (*src != '\"')
					subject += *src;

				src++;
			}
		}
		else if (!strncmp(av[i], "-a:", 3))
		{
			if (!stat(av[i]+3, &st))
				smtp.Attach(av[i]+3);
		}
	}

	if (host.empty() || to.empty() || from.empty())
	{
		cout << "Missing fields" << endl;
		return 1;
	}

	if (!file.empty() && stat(file.data(), &st))
	{
		cout << "Missing data file: " << file << endl;
		return 1;
	}

	AString data;
	int status;
	char buf[256];

	if (file.empty())
	{
		while (!cin.getline(buf, sizeof(buf)).eof())
		{
			data += buf;
			data += '\n';
		}
	}
	else
	{
		ifstream fin(file.data());

		while (!fin.getline(buf, sizeof(buf)).eof())
		{
			data += buf;
			data += '\n';
		}
	}


	if ((status = smtp.Connect(host.Chars())) < 0)
	{
		cout << "Could not connect to: " << host << ", error= " << status << endl;
		return 0;
	}

	if ((status = smtp.Post(from.data(), to.data(), to.data(), subject.data(), data.data(), data.length(), html)) < 0)
	{
		cout << "Could not post to: " << host << ", error= " << status << endl;
		return 0;
	}

	return 0;
}

